;******************************************************************************************
;*	Œm点鐅cpʌv̐
;*	suiiLED.asm		AN0̃xwKAȌヌxɉĂPObƂɂqfa|kdc_ł
;*	2009.7.31.		M.Urushidani
;*	PIC12F683, clock=4MHz(internal osc)
;******************************************************************************************
        LIST    P=12f683
		errorlevel	-302
        #INCLUDE <p12f683.inc>

        __CONFIG _CP_OFF & _CPD_OFF & _WDT_OFF & _BOD_ON & _IESO_OFF& _PWRTE_ON & _INTOSCIO


CNT1mS 		EQU     020h        ;1mS[vJE^
CNT200mS 	EQU     021h        ;200mS[vJE^
CNT1S 		EQU     022h        ;1S[vJE^
CNT10S		EQU		023h		;10S[vJE^
CNTacq		EQU		025h		;ANBWVԗpJE^
AD_save		EQU		026h		;A/Dϊʊi[̈
ZERO_LVL	EQU		030h		;0cm A/D value
delta_LVL	EQU		031h		;A/D - ZERO

        ORG     0

;
INIT
        MOVLW   07h  
        MOVWF   CMCON0      ;GP2-0̓fW^hn  

        BSF     STATUS,RP0  ;oNPɐؑւ
        movlw	B'00010000'	;GP4=input
        movwf	TRISIO
        MOVLW   060h		;CLOCK=4MHz
        MOVWF   OSCCON
		MOVLW	018h		;GP4/AN3(Rԃs)̂݃AiÓC8Tosc(2.0uS)
        movwf	ANSEL
        BCF     STATUS,RP0  ;oNOɐؑւ
		MOVLW	0Dh
		MOVWF	ADCON0		;A/D:l߁Cd:VddC`l:AN3CA/DL
		clrf	GPIO

;C
		call	T1S
		BSF		ADCON0,GO	;A/DϊJn
wait_iniad
		BTFSC	ADCON0,GO	;A/DϊH 0=completed
		goto	wait_iniad
		MOVF	ADRESH,W	;A/Dϊʓǂݏo
		MOVWF	ZERO_LVL
		movlw	B'00000100'	;G on
		movwf	GPIO
		call	T1S
		clrf	GPIO		;G off
		call	T1S
		movlw	B'00000100'	;G on
		movwf	GPIO
		call	T1S
		clrf	GPIO		;G off
;		call	T1S
MAIN
		call	T10S		;T1S

		BSF		ADCON0,GO	;A/DϊJn
wait_ad
		BTFSC	ADCON0,GO	;A/DϊH 0=completed
		goto	wait_ad
		MOVF	ADRESH,W	;A/Dϊʓǂݏo
		MOVWF	AD_save
		
		movf	ZERO_LVL,W
		subwf	AD_save,W	;AD_save - W
		movwf	delta_LVL
		btfss	STATUS,C
		clrf	delta_LVL
		
		movf	delta_LVL,W
		sublw	.4			;.4 - W
		btfss	STATUS,C
		goto	nxt_chk1	;W>.4
		movlw	B'00000010'	;R on
		movwf	GPIO
		call	T1S
		clrf	GPIO		;R off
		goto	MAIN
		
nxt_chk1
		movf	delta_LVL,W
		sublw	.18
		btfss	STATUS,C
		goto	nxt_chk2	;W>.18
		movlw	B'00100000'	;B on
		movwf	GPIO
		call	T1S
		clrf	GPIO		;B off
		goto	MAIN
		
nxt_chk2
		movf	delta_LVL,W
		sublw	.50
		btfss	STATUS,C
		goto	nxt_chk3	;W>.50
		movlw	B'00000100'	;G on
		movwf	GPIO
		call	T1S
		clrf	GPIO		;G off
		goto	MAIN
		
nxt_chk3
		movf	delta_LVL,W
		sublw	.63
		btfss	STATUS,C
		goto	lvl_over		;W>.63
		movlw	B'00100010'	;R+B on
		movwf	GPIO
		call	T1S
		clrf	GPIO		;R+B off
		goto	MAIN

lvl_over
		movlw	B'00100110'	;R+G+B on
		movwf	GPIO
		call	T1S
		clrf	GPIO		;R+G+B off
		goto	MAIN		
		
;EFCg[`

;10S҂
T10S
        MOVLW   D'10'       ; [v10
        MOVWF   CNT10S      ; Zbg
T10LP   CALL    T1S         ; 200mS҂
        DECFSZ  CNT10S,F    ; [v񐔁|PĂOɂȂ玟̖߂XLbv
        GOTO    T10LP
        RETURN


;1S҂
T1S
        MOVLW   D'5'        ; [v񐔂T
        MOVWF   CNT1S       ; Zbg
T1LP    CALL    T200mS      ; 200mS҂
        DECFSZ  CNT1S,F   ; [v񐔁|PĂOɂȂ玟̖߂XLbv
        GOTO    T1LP
        RETURN


;200mS҂
T200mS
        MOVLW   D'200'      ; [v200
        MOVWF   CNT200mS    ; Zbg
T200LP  CALL    T1mS        ; 1mS҂
        DECFSZ  CNT200mS,F  ; [v񐔁|PĂOɂȂ玟̖߂XLbv
        GOTO    T200LP
        RETURN


;1mS҂
T1mS
        MOVLW   D'249'      ; [v249
        MOVWF   CNT1mS      ; Zbg
T1mLP  NOP                  ; PTCN
        DECFSZ  CNT1mS,F    ; [v񐔁|PĂOɂȂ玟̖߂XLbv
        GOTO    T1mLP
        RETURN

;A/DANCWV^C
acquisition
		MOVLW	d'5'
		MOVWF	CNTacq
acq_loop
		DECFSZ	CNTacq,F
		GOTO	acq_loop
		RETURN


        END






























